<?php

/**
 * inf_prenomina_detalle actions.
 *
 * @package    nomina
 * @subpackage inf_prenomina_detalle
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_prenomina_detalleActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc, CODIGO, id_periodo_ajuste ';
        }



        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $num_doc = $request['num_doc'];
            $id_tipo_doc = $request['id_tipo_doc'];

            /*
             * Variables opcionales
             */
            //Area
            if (isset($request['id_area'])) {
                $whereIdArea = " AND car.id_ea = " . $request['id_area'];
            } else {
                $whereIdArea = ' ';
            }
            //Componente escala
            if (isset($request['id_com_esc'])) {
                $whereIdComponenteS = " AND car.id_com_esc = " . $request['id_com_esc'];
            } else {
                $whereIdComponenteS = ' ';
            }
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //centro operacion
            if (isset($request['id_cen_op'])) {
                $whereCenOpe = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOpe = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             * Filtro de conceptos para pago . and concep.pago_func = 1 - 20140428
             */
            /**
             * En el desarrollo del proceso de la liquidación de la nómina de Julio de Colciencias, 
             * como es de tu conocimiento tenemos pendiente entregar el informe de prenómina con 
             * los porcentajes de la prima de méritos, número de horas extras y porcentaje de prima tecnica. - 20140718
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab.cantidad,
liquida.porcentaje as porcentaje,                     
liquida.id_tipo_doc,
liquida.num_doc,
liquida.id_periodo,
--liquida.num_dias as dias,
--case when nvl(liquida.num_dias,0) = 0 then null else liquida.num_dias end,
case when liquida.num_dias is null and ( liquida.id_concep_nomina in (select distinct id_concep_nomina from no_tipo_hr_extra)) then tab.cantidad else 
(case when nvl(liquida.num_dias,0) = 0 then null else liquida.num_dias end) end AS DIAS,
concep.codigo as codigo, 
concep.descripcion as descripcion , 
case when concep.id_tipo_concepto = 1 then liquida.valor_liquidado else 0 end as valor_dev, 
case when concep.id_tipo_concepto != 1 then liquida.valor_liquidado else 0 end as VALOR_ded

FROM no_liquida_nomina liquida

left join no_concep_nomina concep 
ON concep.id_concep_nomina = liquida.id_concep_nomina

left join(

    select
    id_periodo, num_doc, id_concep_nomina, sum(cantidad) as cantidad
    from (
        select
        lotehr.total_horas,
        lotehr.id_periodo,
        hrext.id_tipo_doc,
        hrext.num_doc,
        hrext.cantidad,
        tiphr.id_concep_nomina

        from no_lote_hr_extra lotehr

        left join no_hr_extra hrext
        on lotehr.id_lote_hr_extra = hrext.id_lote_hr_extra

        left join no_tipo_hr_extra tiphr
        on tiphr.id_tipo_hr_extra = hrext.id_tipo_hr_extra

        where lotehr.id_periodo = $periodo_filtro
        and hrext.num_doc =  $num_doc
        and lotehr.estado = 0            
    )

    group by
    id_periodo, num_doc, id_concep_nomina

)tab
on tab.id_periodo = liquida.id_periodo
and tab.num_doc = liquida.num_doc
and tab.id_concep_nomina = liquida.id_concep_nomina

left join NO_DP_V car ON car.titular=liquida.num_doc    
    
where 
liquida.num_doc = $num_doc 
and liquida.id_tipo_doc = $id_tipo_doc     
and liquida.id_periodo = $periodo_filtro  
$whereIdArea       $whereIdComponenteS  
and concep.pago_func = 1
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
    
select 
tab.cantidad,
liquida.porcentaje as porcentaje,                     
liquida.id_tipo_doc,
liquida.num_doc,
liquida.id_periodo,
--liquida.num_dias as dias,
--case when nvl(liquida.num_dias,0) = 0 then null else liquida.num_dias end,
case when liquida.num_dias is null and ( liquida.id_concep_nomina in (select distinct id_concep_nomina from no_tipo_hr_extra)) then tab.cantidad else 
(case when nvl(liquida.num_dias,0) = 0 then null else liquida.num_dias end) end AS DIAS,
concep.codigo as codigo, 
concep.descripcion as descripcion , 
case when concep.id_tipo_concepto = 1 then liquida.valor_liquidado else 0 end as valor_dev, 
case when concep.id_tipo_concepto != 1 then liquida.valor_liquidado else 0 end as VALOR_ded

FROM no_liquida_nomina liquida

left join no_concep_nomina concep 
ON concep.id_concep_nomina = liquida.id_concep_nomina

left join(

    select
    id_periodo, num_doc, id_concep_nomina, sum(cantidad) as cantidad
    from (
        select
        lotehr.total_horas,
        lotehr.id_periodo,
        hrext.id_tipo_doc,
        hrext.num_doc,
        hrext.cantidad,
        tiphr.id_concep_nomina

        from no_lote_hr_extra lotehr

        left join no_hr_extra hrext
        on lotehr.id_lote_hr_extra = hrext.id_lote_hr_extra

        left join no_tipo_hr_extra tiphr
        on tiphr.id_tipo_hr_extra = hrext.id_tipo_hr_extra

        where lotehr.id_periodo = $periodo_filtro
        and hrext.num_doc =  $num_doc
        and lotehr.estado = 0  
    )

    group by
    id_periodo, num_doc, id_concep_nomina

)tab
on tab.id_periodo = liquida.id_periodo
and tab.num_doc = liquida.num_doc
and tab.id_concep_nomina = liquida.id_concep_nomina
                    
left join NO_DP_V car ON car.titular=liquida.num_doc
    
where 
liquida.num_doc = $num_doc 
and liquida.id_tipo_doc = $id_tipo_doc     
and liquida.id_periodo = $periodo_filtro  
$whereIdArea       $whereIdComponenteS    
and concep.pago_func = 1
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_prenomina_detalle] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc, CODIGO ';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $num_doc = $request['num_doc'];
            $id_tipo_doc = $request['id_tipo_doc'];

            /*
             * Variables opcionales
             */
            //Area
            if (isset($request['id_area'])) {
                $whereIdArea = " AND car.id_ea = " . $request['id_area'];
            } else {
                $whereIdArea = ' ';
            }
            //Componente escala
            if (isset($request['id_com_esc'])) {
                $whereIdComponenteS = " AND car.id_com_esc = " . $request['id_com_esc'];
            } else {
                $whereIdComponenteS = ' ';
            }
            //funcionario            
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //centro operacion
            if (isset($request['id_cen_op'])) {
                $whereCenOpe = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOpe = ' ';
            }


            //obtener el listado de recaudos
            // Filtro de conceptos para pago . and concep.pago_func = 1 - 20140428
            $sql = <<<EOD
SELECT

'TOTALES' as codigo,

SUM(valor_dev)  as valor_dev,
SUM(valor_ded)  as valor_ded

FROM (   
 
    select 
    tab.cantidad,
    liquida.porcentaje as porcentaje,                     
    liquida.id_tipo_doc,
    liquida.num_doc,
    liquida.id_periodo,
    --liquida.num_dias as dias,
    --case when nvl(liquida.num_dias,0) = 0 then null else liquida.num_dias end,
    case when liquida.num_dias is null and ( liquida.id_concep_nomina in (select distinct id_concep_nomina from no_tipo_hr_extra)) then tab.cantidad else 
    (case when nvl(liquida.num_dias,0) = 0 then null else liquida.num_dias end) end AS DIAS,
    concep.codigo as codigo, 
    concep.descripcion as descripcion , 
    case when concep.id_tipo_concepto = 1 then liquida.valor_liquidado else 0 end as valor_dev, 
    case when concep.id_tipo_concepto != 1 then liquida.valor_liquidado else 0 end as VALOR_ded

    FROM no_liquida_nomina liquida

    left join no_concep_nomina concep 
    ON concep.id_concep_nomina = liquida.id_concep_nomina

    left join(

        select
        id_periodo, num_doc, id_concep_nomina, sum(cantidad) as cantidad
        from (
            select
            lotehr.total_horas,
            lotehr.id_periodo,
            hrext.id_tipo_doc,
            hrext.num_doc,
            hrext.cantidad,
            tiphr.id_concep_nomina

            from no_lote_hr_extra lotehr

            left join no_hr_extra hrext
            on lotehr.id_lote_hr_extra = hrext.id_lote_hr_extra

            left join no_tipo_hr_extra tiphr
            on tiphr.id_tipo_hr_extra = hrext.id_tipo_hr_extra

            where lotehr.id_periodo = $periodo_filtro
            and hrext.num_doc =  $num_doc
            and lotehr.estado = 0  
        )

        group by
        id_periodo, num_doc, id_concep_nomina

    )tab
    on tab.id_periodo = liquida.id_periodo
    and tab.num_doc = liquida.num_doc
    and tab.id_concep_nomina = liquida.id_concep_nomina
    left join NO_DP_V car ON car.titular=liquida.num_doc   
        
    where 
    liquida.num_doc = $num_doc 
    and liquida.id_tipo_doc = $id_tipo_doc     
    and liquida.id_periodo = $periodo_filtro  
    $whereIdArea       $whereIdComponenteS    
    and concep.pago_func = 1

    $sortBy

)

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
